diff --git a/fw/hpack.c b/fw/hpack.c
index 4234e129c..60e9099dd 100644
--- a/fw/hpack.c
+++ b/fw/hpack.c
@@ -3072,10 +3072,8 @@ tfw_hpack_rbuf_calc(TfwHPackETbl *__restrict tbl, unsigned short new_size,
 	do {
 		unsigned short f_len, fhdr_len;
 
-		if (i >= HPACK_MAX_ENC_EVICTION)
-			return -E2BIG;
-
-		if (last == first) {
+		if (!size) {
+table_is_empty:
 			it->first = it->last = NULL;
 			it->rb_len = it->size = 0;
 			WARN_ON_ONCE(it->rb_size != HPACK_ENC_TABLE_MAX_SIZE);
@@ -3084,6 +3082,9 @@ tfw_hpack_rbuf_calc(TfwHPackETbl *__restrict tbl, unsigned short new_size,
 			return 0;
 		}
 
+		if (i >= HPACK_MAX_ENC_EVICTION)
+			return -E2BIG;
+
 		f_len = HPACK_NODE_SIZE(first);
 		fhdr_len = ((TfwHPackNode *)first)->hdr_len;
 
@@ -3110,6 +3111,9 @@ tfw_hpack_rbuf_calc(TfwHPackETbl *__restrict tbl, unsigned short new_size,
 
 	} while (size > new_size);
 
+	if (unlikely(!size))
+		goto table_is_empty;
+
 	it->size = size;
 	it->rb_len = rb_len;
 	it->first = (TfwHPackNode *)first;
